#ifndef _H_CD01A5631233022184A22B8C937130E4_PositionSetpoint__H_
#define _H_CD01A5631233022184A22B8C937130E4_PositionSetpoint__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            const ::DDS::Octet PositionSetpoint__SETPOINT_TYPE_POSITION = 0;

            const ::DDS::Octet PositionSetpoint__SETPOINT_TYPE_VELOCITY = 1;

            const ::DDS::Octet PositionSetpoint__SETPOINT_TYPE_LOITER = 2;

            const ::DDS::Octet PositionSetpoint__SETPOINT_TYPE_TAKEOFF = 3;

            const ::DDS::Octet PositionSetpoint__SETPOINT_TYPE_LAND = 4;

            const ::DDS::Octet PositionSetpoint__SETPOINT_TYPE_IDLE = 5;

            const ::DDS::Octet PositionSetpoint__SETPOINT_TYPE_OFFBOARD = 6;

            const ::DDS::Octet PositionSetpoint__SETPOINT_TYPE_FOLLOW_TARGET = 7;

            const ::DDS::Octet PositionSetpoint__VELOCITY_FRAME_LOCAL_NED = 1;

            const ::DDS::Octet PositionSetpoint__VELOCITY_FRAME_BODY_NED = 8;

            struct  PositionSetpoint_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Boolean valid_;
                ::DDS::Octet type_;
                ::DDS::Float x_;
                ::DDS::Float y_;
                ::DDS::Float z_;
                ::DDS::Boolean position_valid_;
                ::DDS::Float vx_;
                ::DDS::Float vy_;
                ::DDS::Float vz_;
                ::DDS::Boolean velocity_valid_;
                ::DDS::Octet velocity_frame_;
                ::DDS::Boolean alt_valid_;
                ::DDS::Double lat_;
                ::DDS::Double lon_;
                ::DDS::Float alt_;
                ::DDS::Float yaw_;
                ::DDS::Boolean yaw_valid_;
                ::DDS::Float yawspeed_;
                ::DDS::Boolean yawspeed_valid_;
                ::DDS::Octet landing_gear_;
                ::DDS::Float loiter_radius_;
                ::DDS::Octet loiter_direction_;
                ::DDS::Float pitch_min_;
                ::DDS::Float a_x_;
                ::DDS::Float a_y_;
                ::DDS::Float a_z_;
                ::DDS::Boolean acceleration_valid_;
                ::DDS::Boolean acceleration_is_force_;
                ::DDS::Float acceptance_radius_;
                ::DDS::Float cruising_speed_;
                ::DDS::Float cruising_throttle_;
                ::DDS::Boolean allow_weather_vane_;
            };

            typedef DDS_DCPSStruct_var<PositionSetpoint_> PositionSetpoint__var;
            typedef PositionSetpoint_& PositionSetpoint__out;

        }

    }

}

#endif /* _H_CD01A5631233022184A22B8C937130E4_PositionSetpoint__H_ */
