#ifndef _H_4EFDB274796DDAC818D308B6BFBF99DF_TelemetryStatus__H_
#define _H_4EFDB274796DDAC818D308B6BFBF99DF_TelemetryStatus__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            const ::DDS::Octet TelemetryStatus__LINK_TYPE_GENERIC = 0;

            const ::DDS::Octet TelemetryStatus__LINK_TYPE_3DR_RADIO = 1;

            const ::DDS::Octet TelemetryStatus__LINK_TYPE_UBIQUITY_BULLET = 2;

            const ::DDS::Octet TelemetryStatus__LINK_TYPE_WIRE = 3;

            const ::DDS::Octet TelemetryStatus__LINK_TYPE_USB = 4;

            const ::DDS::Octet TelemetryStatus__LINK_TYPE_IRIDIUM = 5;

            const ::DDS::Octet TelemetryStatus__COMPONENT_ID_ALL = 0;

            const ::DDS::Octet TelemetryStatus__COMPONENT_ID_AUTOPILOT1 = 1;

            const ::DDS::Octet TelemetryStatus__COMPONENT_ID_CAMERA = 100;

            const ::DDS::Octet TelemetryStatus__COMPONENT_ID_OBSTACLE_AVOIDANCE = 196;

            const ::DDS::Octet TelemetryStatus__MAV_TYPE_GENERIC = 0;

            const ::DDS::Octet TelemetryStatus__MAV_TYPE_GCS = 6;

            const ::DDS::Octet TelemetryStatus__MAV_TYPE_ONBOARD_CONTROLLER = 18;

            const ::DDS::Octet TelemetryStatus__MAV_STATE_UNINIT = 0;

            const ::DDS::Octet TelemetryStatus__MAV_STATE_BOOT = 1;

            const ::DDS::Octet TelemetryStatus__MAV_STATE_CALIBRATING = 2;

            const ::DDS::Octet TelemetryStatus__MAV_STATE_STANDBY = 3;

            const ::DDS::Octet TelemetryStatus__MAV_STATE_ACTIVE = 4;

            const ::DDS::Octet TelemetryStatus__MAV_STATE_CRITICAL = 5;

            const ::DDS::Octet TelemetryStatus__MAV_STATE_EMERGENCY = 6;

            const ::DDS::Octet TelemetryStatus__MAV_STATE_POWEROFF = 7;

            const ::DDS::Octet TelemetryStatus__MAV_STATE_FLIGHT_TERMINATION = 8;

            const ::DDS::Octet TelemetryStatus__ORB_QUEUE_LENGTH = 3;

            struct  TelemetryStatus_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::ULongLong heartbeat_time_;
                ::DDS::Octet remote_system_id_;
                ::DDS::Octet remote_component_id_;
                ::DDS::Octet remote_type_;
                ::DDS::Octet remote_system_status_;
                ::DDS::Octet type_;
                ::DDS::Octet mode_;
                ::DDS::Boolean flow_control_;
                ::DDS::Boolean forwarding_;
                ::DDS::Boolean mavlink_v2_;
                ::DDS::Boolean ftp_;
                ::DDS::Octet streams_;
                ::DDS::Float data_rate_;
                ::DDS::Float rate_multiplier_;
                ::DDS::Float rate_rx_;
                ::DDS::Float rate_tx_;
                ::DDS::Float rate_txerr_;
            };

            typedef DDS_DCPSStruct_var<TelemetryStatus_> TelemetryStatus__var;
            typedef TelemetryStatus_& TelemetryStatus__out;

        }

    }

}

#endif /* _H_4EFDB274796DDAC818D308B6BFBF99DF_TelemetryStatus__H_ */
