#ifndef _H_1FD025531559538A8E1FADBEB89F3836_VehicleStatus__H_
#define _H_1FD025531559538A8E1FADBEB89F3836_VehicleStatus__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace px4_msgs
{
    namespace msg
    {
        namespace dds_
        {
            const ::DDS::Octet VehicleStatus__ARMING_STATE_INIT = 0;

            const ::DDS::Octet VehicleStatus__ARMING_STATE_STANDBY = 1;

            const ::DDS::Octet VehicleStatus__ARMING_STATE_ARMED = 2;

            const ::DDS::Octet VehicleStatus__ARMING_STATE_STANDBY_ERROR = 3;

            const ::DDS::Octet VehicleStatus__ARMING_STATE_SHUTDOWN = 4;

            const ::DDS::Octet VehicleStatus__ARMING_STATE_IN_AIR_RESTORE = 5;

            const ::DDS::Octet VehicleStatus__ARMING_STATE_MAX = 6;

            const ::DDS::Octet VehicleStatus__FAILURE_NONE = 0;

            const ::DDS::Octet VehicleStatus__FAILURE_ROLL = 1;

            const ::DDS::Octet VehicleStatus__FAILURE_PITCH = 2;

            const ::DDS::Octet VehicleStatus__FAILURE_ALT = 4;

            const ::DDS::Octet VehicleStatus__HIL_STATE_OFF = 0;

            const ::DDS::Octet VehicleStatus__HIL_STATE_ON = 1;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_MANUAL = 0;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_ALTCTL = 1;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_POSCTL = 2;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_AUTO_MISSION = 3;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_AUTO_LOITER = 4;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_AUTO_RTL = 5;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_AUTO_RCRECOVER = 6;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_AUTO_RTGS = 7;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_AUTO_LANDENGFAIL = 8;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_AUTO_LANDGPSFAIL = 9;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_ACRO = 10;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_UNUSED = 11;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_DESCEND = 12;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_TERMINATION = 13;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_OFFBOARD = 14;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_STAB = 15;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_RATTITUDE = 16;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_AUTO_TAKEOFF = 17;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_AUTO_LAND = 18;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_AUTO_FOLLOW_TARGET = 19;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_AUTO_PRECLAND = 20;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_ORBIT = 21;

            const ::DDS::Octet VehicleStatus__NAVIGATION_STATE_MAX = 22;

            const ::DDS::Octet VehicleStatus__RC_IN_MODE_DEFAULT = 0;

            const ::DDS::Octet VehicleStatus__RC_IN_MODE_OFF = 1;

            const ::DDS::Octet VehicleStatus__RC_IN_MODE_GENERATED = 2;

            const ::DDS::Octet VehicleStatus__VEHICLE_TYPE_UNKNOWN = 0;

            const ::DDS::Octet VehicleStatus__VEHICLE_TYPE_ROTARY_WING = 1;

            const ::DDS::Octet VehicleStatus__VEHICLE_TYPE_FIXED_WING = 2;

            const ::DDS::Octet VehicleStatus__VEHICLE_TYPE_ROVER = 3;

            struct  VehicleStatus_
            {
                ::DDS::ULongLong timestamp_;
                ::DDS::Octet nav_state_;
                ::DDS::Octet arming_state_;
                ::DDS::Octet hil_state_;
                ::DDS::Boolean failsafe_;
                ::DDS::Octet system_type_;
                ::DDS::Octet system_id_;
                ::DDS::Octet component_id_;
                ::DDS::Octet vehicle_type_;
                ::DDS::Boolean is_vtol_;
                ::DDS::Boolean vtol_fw_permanent_stab_;
                ::DDS::Boolean in_transition_mode_;
                ::DDS::Boolean in_transition_to_fw_;
                ::DDS::Boolean rc_signal_lost_;
                ::DDS::Octet rc_input_mode_;
                ::DDS::Boolean data_link_lost_;
                ::DDS::Octet data_link_lost_counter_;
                ::DDS::Boolean high_latency_data_link_lost_;
                ::DDS::Boolean engine_failure_;
                ::DDS::Boolean mission_failure_;
                ::DDS::Octet failure_detector_status_;
                ::DDS::ULong onboard_control_sensors_present_;
                ::DDS::ULong onboard_control_sensors_enabled_;
                ::DDS::ULong onboard_control_sensors_health_;
                ::DDS::Float arspd_check_level_;
                ::DDS::Boolean aspd_check_failing_;
                ::DDS::Boolean aspd_fault_declared_;
                ::DDS::Boolean aspd_use_inhibit_;
                ::DDS::Boolean aspd_fail_rtl_;
                ::DDS::Float load_factor_ratio_;
            };

            typedef DDS_DCPSStruct_var<VehicleStatus_> VehicleStatus__var;
            typedef VehicleStatus_& VehicleStatus__out;

        }

    }

}

#endif /* _H_1FD025531559538A8E1FADBEB89F3836_VehicleStatus__H_ */
