# generated from rosidl_generator_py/resource/_msg.py.em
# generated code does not contain a copyright notice

from copy import copy
import logging
import traceback


class Metaclass(type):
    """Metaclass of message 'SatelliteInfo'."""

    _CREATE_ROS_MESSAGE = None
    _CONVERT_FROM_PY = None
    _CONVERT_TO_PY = None
    _DESTROY_ROS_MESSAGE = None
    _TYPE_SUPPORT = None

    __constants = {
        'SAT_INFO_MAX_SATELLITES': 20,
    }

    @classmethod
    def __import_type_support__(cls):
        try:
            from rosidl_generator_py import import_type_support
            module = import_type_support('px4_msgs')
        except ImportError:
            logger = logging.getLogger('rosidl_generator_py.SatelliteInfo')
            logger.debug(
                'Failed to import needed modules for type support:\n' + traceback.format_exc())
        else:
            cls._CREATE_ROS_MESSAGE = module.create_ros_message_msg__msg_satellite_info
            cls._CONVERT_FROM_PY = module.convert_from_py_msg__msg_satellite_info
            cls._CONVERT_TO_PY = module.convert_to_py_msg__msg_satellite_info
            cls._TYPE_SUPPORT = module.type_support_msg__msg_satellite_info
            cls._DESTROY_ROS_MESSAGE = module.destroy_ros_message_msg__msg_satellite_info

    @classmethod
    def __prepare__(cls, name, bases, **kwargs):
        # list constant names here so that they appear in the help text of
        # the message class under "Data and other attributes defined here:"
        # as well as populate each message instance
        return {
            'SAT_INFO_MAX_SATELLITES': cls.__constants['SAT_INFO_MAX_SATELLITES'],
        }

    @property
    def SAT_INFO_MAX_SATELLITES(self):
        """Message constant 'SAT_INFO_MAX_SATELLITES'."""
        return Metaclass.__constants['SAT_INFO_MAX_SATELLITES']


class SatelliteInfo(metaclass=Metaclass):
    """
    Message class 'SatelliteInfo'.

    Constants:
      SAT_INFO_MAX_SATELLITES
    """

    __slots__ = [
        '_timestamp',
        '_count',
        '_svid',
        '_used',
        '_elevation',
        '_azimuth',
        '_snr',
    ]

    _fields_and_field_types = {
        'timestamp': 'uint64',
        'count': 'uint8',
        'svid': 'uint8[20]',
        'used': 'uint8[20]',
        'elevation': 'uint8[20]',
        'azimuth': 'uint8[20]',
        'snr': 'uint8[20]',
    }

    def __init__(self, **kwargs):
        assert all('_' + key in self.__slots__ for key in kwargs.keys()), \
            'Invalid arguments passed to constructor: %s' % \
            ', '.join(sorted(k for k in kwargs.keys() if '_' + k not in self.__slots__))
        self.timestamp = kwargs.get('timestamp', int())
        self.count = kwargs.get('count', int())
        self.svid = kwargs.get(
            'svid',
            [int() for x in range(20)]
        )
        self.used = kwargs.get(
            'used',
            [int() for x in range(20)]
        )
        self.elevation = kwargs.get(
            'elevation',
            [int() for x in range(20)]
        )
        self.azimuth = kwargs.get(
            'azimuth',
            [int() for x in range(20)]
        )
        self.snr = kwargs.get(
            'snr',
            [int() for x in range(20)]
        )

    def __repr__(self):
        typename = self.__class__.__module__.split('.')
        typename.pop()
        typename.append(self.__class__.__name__)
        args = [s[1:] + '=' + repr(getattr(self, s, None)) for s in self.__slots__]
        return '%s(%s)' % ('.'.join(typename), ', '.join(args))

    def __eq__(self, other):
        if not isinstance(other, self.__class__):
            return False
        if self.timestamp != other.timestamp:
            return False
        if self.count != other.count:
            return False
        if self.svid != other.svid:
            return False
        if self.used != other.used:
            return False
        if self.elevation != other.elevation:
            return False
        if self.azimuth != other.azimuth:
            return False
        if self.snr != other.snr:
            return False
        return True

    @classmethod
    def get_fields_and_field_types(cls):
        return copy(cls._fields_and_field_types)

    @property
    def timestamp(self):
        """Message field 'timestamp'."""
        return self._timestamp

    @timestamp.setter
    def timestamp(self, value):
        if __debug__:
            assert \
                isinstance(value, int), \
                "The 'timestamp' field must of type 'int'"
            assert value >= 0 and value < 18446744073709551616, \
                "The 'timestamp' field must be an unsigned integer in [0, 18446744073709551615]"
        self._timestamp = value

    @property
    def count(self):
        """Message field 'count'."""
        return self._count

    @count.setter
    def count(self, value):
        if __debug__:
            assert \
                isinstance(value, int), \
                "The 'count' field must of type 'int'"
            assert value >= 0 and value < 256, \
                "The 'count' field must be an unsigned integer in [0, 255]"
        self._count = value

    @property
    def svid(self):
        """Message field 'svid'."""
        return self._svid

    @svid.setter
    def svid(self, value):
        if __debug__:
            from collections.abc import Sequence
            from collections.abc import Set
            from collections import UserList
            from collections import UserString
            assert \
                ((isinstance(value, Sequence) or
                  isinstance(value, Set) or
                  isinstance(value, UserList)) and
                 not isinstance(value, str) and
                 not isinstance(value, UserString) and
                 len(value) == 20 and
                 all(isinstance(v, int) for v in value) and
                 all(val >= 0 and val < 256 for val in value)), \
                "The 'svid' field must be a set or sequence with length 20 and each value of type 'int' and each unsigned integer in [0, 255]"
        self._svid = value

    @property
    def used(self):
        """Message field 'used'."""
        return self._used

    @used.setter
    def used(self, value):
        if __debug__:
            from collections.abc import Sequence
            from collections.abc import Set
            from collections import UserList
            from collections import UserString
            assert \
                ((isinstance(value, Sequence) or
                  isinstance(value, Set) or
                  isinstance(value, UserList)) and
                 not isinstance(value, str) and
                 not isinstance(value, UserString) and
                 len(value) == 20 and
                 all(isinstance(v, int) for v in value) and
                 all(val >= 0 and val < 256 for val in value)), \
                "The 'used' field must be a set or sequence with length 20 and each value of type 'int' and each unsigned integer in [0, 255]"
        self._used = value

    @property
    def elevation(self):
        """Message field 'elevation'."""
        return self._elevation

    @elevation.setter
    def elevation(self, value):
        if __debug__:
            from collections.abc import Sequence
            from collections.abc import Set
            from collections import UserList
            from collections import UserString
            assert \
                ((isinstance(value, Sequence) or
                  isinstance(value, Set) or
                  isinstance(value, UserList)) and
                 not isinstance(value, str) and
                 not isinstance(value, UserString) and
                 len(value) == 20 and
                 all(isinstance(v, int) for v in value) and
                 all(val >= 0 and val < 256 for val in value)), \
                "The 'elevation' field must be a set or sequence with length 20 and each value of type 'int' and each unsigned integer in [0, 255]"
        self._elevation = value

    @property
    def azimuth(self):
        """Message field 'azimuth'."""
        return self._azimuth

    @azimuth.setter
    def azimuth(self, value):
        if __debug__:
            from collections.abc import Sequence
            from collections.abc import Set
            from collections import UserList
            from collections import UserString
            assert \
                ((isinstance(value, Sequence) or
                  isinstance(value, Set) or
                  isinstance(value, UserList)) and
                 not isinstance(value, str) and
                 not isinstance(value, UserString) and
                 len(value) == 20 and
                 all(isinstance(v, int) for v in value) and
                 all(val >= 0 and val < 256 for val in value)), \
                "The 'azimuth' field must be a set or sequence with length 20 and each value of type 'int' and each unsigned integer in [0, 255]"
        self._azimuth = value

    @property
    def snr(self):
        """Message field 'snr'."""
        return self._snr

    @snr.setter
    def snr(self, value):
        if __debug__:
            from collections.abc import Sequence
            from collections.abc import Set
            from collections import UserList
            from collections import UserString
            assert \
                ((isinstance(value, Sequence) or
                  isinstance(value, Set) or
                  isinstance(value, UserList)) and
                 not isinstance(value, str) and
                 not isinstance(value, UserString) and
                 len(value) == 20 and
                 all(isinstance(v, int) for v in value) and
                 all(val >= 0 and val < 256 for val in value)), \
                "The 'snr' field must be a set or sequence with length 20 and each value of type 'int' and each unsigned integer in [0, 255]"
        self._snr = value
