# generated from rosidl_generator_py/resource/_msg.py.em
# generated code does not contain a copyright notice

from copy import copy
import logging
import traceback


class Metaclass(type):
    """Metaclass of message 'SensorCombined'."""

    _CREATE_ROS_MESSAGE = None
    _CONVERT_FROM_PY = None
    _CONVERT_TO_PY = None
    _DESTROY_ROS_MESSAGE = None
    _TYPE_SUPPORT = None

    __constants = {
        'RELATIVE_TIMESTAMP_INVALID': 2147483647,
    }

    @classmethod
    def __import_type_support__(cls):
        try:
            from rosidl_generator_py import import_type_support
            module = import_type_support('px4_msgs')
        except ImportError:
            logger = logging.getLogger('rosidl_generator_py.SensorCombined')
            logger.debug(
                'Failed to import needed modules for type support:\n' + traceback.format_exc())
        else:
            cls._CREATE_ROS_MESSAGE = module.create_ros_message_msg__msg_sensor_combined
            cls._CONVERT_FROM_PY = module.convert_from_py_msg__msg_sensor_combined
            cls._CONVERT_TO_PY = module.convert_to_py_msg__msg_sensor_combined
            cls._TYPE_SUPPORT = module.type_support_msg__msg_sensor_combined
            cls._DESTROY_ROS_MESSAGE = module.destroy_ros_message_msg__msg_sensor_combined

    @classmethod
    def __prepare__(cls, name, bases, **kwargs):
        # list constant names here so that they appear in the help text of
        # the message class under "Data and other attributes defined here:"
        # as well as populate each message instance
        return {
            'RELATIVE_TIMESTAMP_INVALID': cls.__constants['RELATIVE_TIMESTAMP_INVALID'],
        }

    @property
    def RELATIVE_TIMESTAMP_INVALID(self):
        """Message constant 'RELATIVE_TIMESTAMP_INVALID'."""
        return Metaclass.__constants['RELATIVE_TIMESTAMP_INVALID']


class SensorCombined(metaclass=Metaclass):
    """
    Message class 'SensorCombined'.

    Constants:
      RELATIVE_TIMESTAMP_INVALID
    """

    __slots__ = [
        '_timestamp',
        '_gyro_rad',
        '_gyro_integral_dt',
        '_accelerometer_timestamp_relative',
        '_accelerometer_m_s2',
        '_accelerometer_integral_dt',
    ]

    _fields_and_field_types = {
        'timestamp': 'uint64',
        'gyro_rad': 'float32[3]',
        'gyro_integral_dt': 'uint32',
        'accelerometer_timestamp_relative': 'int32',
        'accelerometer_m_s2': 'float32[3]',
        'accelerometer_integral_dt': 'uint32',
    }

    def __init__(self, **kwargs):
        assert all('_' + key in self.__slots__ for key in kwargs.keys()), \
            'Invalid arguments passed to constructor: %s' % \
            ', '.join(sorted(k for k in kwargs.keys() if '_' + k not in self.__slots__))
        self.timestamp = kwargs.get('timestamp', int())
        self.gyro_rad = kwargs.get(
            'gyro_rad',
            [float() for x in range(3)]
        )
        self.gyro_integral_dt = kwargs.get('gyro_integral_dt', int())
        self.accelerometer_timestamp_relative = kwargs.get('accelerometer_timestamp_relative', int())
        self.accelerometer_m_s2 = kwargs.get(
            'accelerometer_m_s2',
            [float() for x in range(3)]
        )
        self.accelerometer_integral_dt = kwargs.get('accelerometer_integral_dt', int())

    def __repr__(self):
        typename = self.__class__.__module__.split('.')
        typename.pop()
        typename.append(self.__class__.__name__)
        args = [s[1:] + '=' + repr(getattr(self, s, None)) for s in self.__slots__]
        return '%s(%s)' % ('.'.join(typename), ', '.join(args))

    def __eq__(self, other):
        if not isinstance(other, self.__class__):
            return False
        if self.timestamp != other.timestamp:
            return False
        if self.gyro_rad != other.gyro_rad:
            return False
        if self.gyro_integral_dt != other.gyro_integral_dt:
            return False
        if self.accelerometer_timestamp_relative != other.accelerometer_timestamp_relative:
            return False
        if self.accelerometer_m_s2 != other.accelerometer_m_s2:
            return False
        if self.accelerometer_integral_dt != other.accelerometer_integral_dt:
            return False
        return True

    @classmethod
    def get_fields_and_field_types(cls):
        return copy(cls._fields_and_field_types)

    @property
    def timestamp(self):
        """Message field 'timestamp'."""
        return self._timestamp

    @timestamp.setter
    def timestamp(self, value):
        if __debug__:
            assert \
                isinstance(value, int), \
                "The 'timestamp' field must of type 'int'"
            assert value >= 0 and value < 18446744073709551616, \
                "The 'timestamp' field must be an unsigned integer in [0, 18446744073709551615]"
        self._timestamp = value

    @property
    def gyro_rad(self):
        """Message field 'gyro_rad'."""
        return self._gyro_rad

    @gyro_rad.setter
    def gyro_rad(self, value):
        if __debug__:
            from collections.abc import Sequence
            from collections.abc import Set
            from collections import UserList
            from collections import UserString
            assert \
                ((isinstance(value, Sequence) or
                  isinstance(value, Set) or
                  isinstance(value, UserList)) and
                 not isinstance(value, str) and
                 not isinstance(value, UserString) and
                 len(value) == 3 and
                 all(isinstance(v, float) for v in value) and
                 True), \
                "The 'gyro_rad' field must be a set or sequence with length 3 and each value of type 'float'"
        self._gyro_rad = value

    @property
    def gyro_integral_dt(self):
        """Message field 'gyro_integral_dt'."""
        return self._gyro_integral_dt

    @gyro_integral_dt.setter
    def gyro_integral_dt(self, value):
        if __debug__:
            assert \
                isinstance(value, int), \
                "The 'gyro_integral_dt' field must of type 'int'"
            assert value >= 0 and value < 4294967296, \
                "The 'gyro_integral_dt' field must be an unsigned integer in [0, 4294967295]"
        self._gyro_integral_dt = value

    @property
    def accelerometer_timestamp_relative(self):
        """Message field 'accelerometer_timestamp_relative'."""
        return self._accelerometer_timestamp_relative

    @accelerometer_timestamp_relative.setter
    def accelerometer_timestamp_relative(self, value):
        if __debug__:
            assert \
                isinstance(value, int), \
                "The 'accelerometer_timestamp_relative' field must of type 'int'"
            assert value >= -2147483648 and value < 2147483648, \
                "The 'accelerometer_timestamp_relative' field must be an integer in [-2147483648, 2147483647]"
        self._accelerometer_timestamp_relative = value

    @property
    def accelerometer_m_s2(self):
        """Message field 'accelerometer_m_s2'."""
        return self._accelerometer_m_s2

    @accelerometer_m_s2.setter
    def accelerometer_m_s2(self, value):
        if __debug__:
            from collections.abc import Sequence
            from collections.abc import Set
            from collections import UserList
            from collections import UserString
            assert \
                ((isinstance(value, Sequence) or
                  isinstance(value, Set) or
                  isinstance(value, UserList)) and
                 not isinstance(value, str) and
                 not isinstance(value, UserString) and
                 len(value) == 3 and
                 all(isinstance(v, float) for v in value) and
                 True), \
                "The 'accelerometer_m_s2' field must be a set or sequence with length 3 and each value of type 'float'"
        self._accelerometer_m_s2 = value

    @property
    def accelerometer_integral_dt(self):
        """Message field 'accelerometer_integral_dt'."""
        return self._accelerometer_integral_dt

    @accelerometer_integral_dt.setter
    def accelerometer_integral_dt(self, value):
        if __debug__:
            assert \
                isinstance(value, int), \
                "The 'accelerometer_integral_dt' field must of type 'int'"
            assert value >= 0 and value < 4294967296, \
                "The 'accelerometer_integral_dt' field must be an unsigned integer in [0, 4294967295]"
        self._accelerometer_integral_dt = value
